# Interface MinilinksResult<L>

interface MinilinksResult<L> {
_updating: boolean;
byFrom: {
[id: Id]: Links<Id, L>;
};
byId: {
[id: Id]: L;
};
byTo: {
[id: Id]: Links<Id, L>;
};
byType: {
[id: Id]: Links<Id, L>;
};
deep?: DeepClient<Link<Id>>;
emitter: EventEmitter<DefaultEventMap>;
links: Links<Id, L>;
options: MinilinksGeneratorOptions;
types: {
[id: Id]: Links<Id, L>;
};
useMinilinksApply: (<L>(ml: any, name: string, data?: MinilinksApplyInput | Links<Id, L>) => {
anomalies?: MinilinkError[];
data: L[];
errors?: MinilinkError[];
plainLinks: L[];
});
useMinilinksFilter: (<L, R>(ml: any, filter: ((currentLink: L, oldLink: L, newLink: L) => boolean), results: ((l?: L, ml?: any, oldLink?: L, newLink?: L) => R), interval?: number) => R);
useMinilinksHandle: (<L>(ml: any, handler: ((event: any, oldLink: any, newLink: any) => any)) => void);
useMinilinksId: ((ml: any, start: QueryLink | DeepClientStartItem, ...path: DeepClientPathItem[]) => Id | void);
useMinilinksQuery: (<L>(ml: any, query: Id | QueryLink, options?: MinilinksQueryOptions<MinilinksQueryOptionAggregate>) => any);
useMinilinksSubscription: (<L>(ml: any, query: Id | QueryLink, options?: MinilinksQueryOptions<MinilinksQueryOptionAggregate>) => any);
virtual: {
[id: Id]: Id;
};
virtualCounter: number;
_traveled(a: any[]): Links<Id, L>;
add(linksArray: any[], applyName?: string): {
anomalies?: MinilinkError[];
errors?: MinilinkError[];
};
apply(linksArray: any[] | MinilinksApplyInput, applyName?: string, applyOptions?: ApplyOptions): {
anomalies?: MinilinkError[];
data: L[];
errors?: MinilinkError[];
plainLinks: L[];
};
id(start: DeepClientStartItem, ...path: DeepClientPathItem[]): Id;
name(input: Id | Link<Id>): string;
query(query: Id | QueryLink): any;
remove(idsArray: any[], applyName?: string): {
anomalies?: MinilinkError[];
errors?: MinilinkError[];
};
select(query: Id | QueryLink, options?: MinilinksQueryOptions<MinilinksQueryOptionAggregate>): any;
subscribe(query: Id | QueryLink, options?: MinilinksQueryOptions<MinilinksQueryOptionAggregate>): Observable<any>;
symbol(input: Id | Link<Id>): string;
update(linksArray: any[], applyName?: string): {
anomalies?: MinilinkError[];
errors?: MinilinkError[];
};
}

#### Type Parameters

- L extends Link<Id>

- Defined in work/deeplinks/deeplinks/imports/minilinks.tsx:76

#####
Index

### Properties

_updating
byFrom
byId
byTo
byType
deep?
emitter
links
options
types
useMinilinksApply
useMinilinksFilter
useMinilinksHandle
useMinilinksId
useMinilinksQuery
useMinilinksSubscription
virtual
virtualCounter

### Methods

_traveled
add
apply
id
name
query
remove
select
subscribe
symbol
update

##
Properties

### _updating

_updating: boolean

- Defined in work/deeplinks/deeplinks/imports/minilinks.tsx:110

### byFrom

byFrom: {
[id: Id]: Links<Id, L>;
}

- Defined in work/deeplinks/deeplinks/imports/minilinks.tsx:91

### byId

byId: {
[id: Id]: L;
}

- Defined in work/deeplinks/deeplinks/imports/minilinks.tsx:90

### byTo

byTo: {
[id: Id]: Links<Id, L>;
}

- Defined in work/deeplinks/deeplinks/imports/minilinks.tsx:92

### byType

byType: {
[id: Id]: Links<Id, L>;
}

- Defined in work/deeplinks/deeplinks/imports/minilinks.tsx:93

### `Optional` deep

deep?: DeepClient<Link<Id>>

- Defined in work/deeplinks/deeplinks/imports/minilinks.tsx:77

### emitter

emitter: EventEmitter<DefaultEventMap>

- Defined in work/deeplinks/deeplinks/imports/minilinks.tsx:95

### links

links: Links<Id, L>

- Defined in work/deeplinks/deeplinks/imports/minilinks.tsx:88

### options

options: MinilinksGeneratorOptions

- Defined in work/deeplinks/deeplinks/imports/minilinks.tsx:94

### types

types: {
[id: Id]: Links<Id, L>;
}

- Defined in work/deeplinks/deeplinks/imports/minilinks.tsx:89

### useMinilinksApply

useMinilinksApply: (<L>(ml: any, name: string, data?: MinilinksApplyInput | Links<Id, L>) => {
anomalies?: MinilinkError[];
data: L[];
errors?: MinilinkError[];
plainLinks: L[];
})

- Defined in work/deeplinks/deeplinks/imports/minilinks.tsx:81

### useMinilinksFilter

useMinilinksFilter: (<L, R>(ml: any, filter: ((currentLink: L, oldLink: L, newLink: L) => boolean), results: ((l?: L, ml?: any, oldLink?: L, newLink?: L) => R), interval?: number) => R)

- Defined in work/deeplinks/deeplinks/imports/minilinks.tsx:80

### useMinilinksHandle

useMinilinksHandle: (<L>(ml: any, handler: ((event: any, oldLink: any, newLink: any) => any)) => void)

- Defined in work/deeplinks/deeplinks/imports/minilinks.tsx:84

### useMinilinksId

useMinilinksId: ((ml: any, start: QueryLink | DeepClientStartItem, ...path: DeepClientPathItem[]) => Id | void)

- Defined in work/deeplinks/deeplinks/imports/minilinks.tsx:83

### useMinilinksQuery

useMinilinksQuery: (<L>(ml: any, query: Id | QueryLink, options?: MinilinksQueryOptions<MinilinksQueryOptionAggregate>) => any)

#### Type declaration

- - <L>(ml, query, options?): any

  - React hook. Returns reactiviely links from minilinks, by query in deeplinks dialect. Recalculates when query changes. (Take query into useMemo!).

    #### Type Parameters

    - L extends Link<Id>

    #### Parameters

    - ml: any
    - query: Id | QueryLink
    - `Optional` options: MinilinksQueryOptions<MinilinksQueryOptionAggregate>

    #### Returns any

- Defined in work/deeplinks/deeplinks/imports/minilinks.tsx:79

### useMinilinksSubscription

useMinilinksSubscription: (<L>(ml: any, query: Id | QueryLink, options?: MinilinksQueryOptions<MinilinksQueryOptionAggregate>) => any)

#### Type declaration

- - <L>(ml, query, options?): any

  - React hook. Returns reactiviely links from minilinks, by query in deeplinks dialect. Recalculates when data in minilinks changes. (Take query into useMemo!).

    #### Type Parameters

    - L extends Link<Id>

    #### Parameters

    - ml: any
    - query: Id | QueryLink
    - `Optional` options: MinilinksQueryOptions<MinilinksQueryOptionAggregate>

    #### Returns any

- Defined in work/deeplinks/deeplinks/imports/minilinks.tsx:82

### virtual

virtual: {
[id: Id]: Id;
}

- Defined in work/deeplinks/deeplinks/imports/minilinks.tsx:86

### virtualCounter

virtualCounter: number

- Defined in work/deeplinks/deeplinks/imports/minilinks.tsx:87

##
Methods

### _traveled

- _traveled(a): Links<Id, L>

- #### Parameters

  - a: any[]

  #### Returns Links<Id, L>

  - Defined in work/deeplinks/deeplinks/imports/minilinks.tsx:121

### add

- add(linksArray, applyName?): {
  anomalies?: MinilinkError[];
  errors?: MinilinkError[];
  }

- #### Parameters

  - linksArray: any[]
  - `Optional` applyName: string

  #### Returns {
  anomalies?: MinilinkError[];
  errors?: MinilinkError[];
  }

  - ##### `Optional` anomalies?: MinilinkError[]

  - ##### `Optional` errors?: MinilinkError[]

  - Defined in work/deeplinks/deeplinks/imports/minilinks.tsx:102

### apply

- apply(linksArray, applyName?, applyOptions?): {
  anomalies?: MinilinkError[];
  data: L[];
  errors?: MinilinkError[];
  plainLinks: L[];
  }

- #### Parameters

  - linksArray: any[] | MinilinksApplyInput
  - `Optional` applyName: string
  - `Optional` applyOptions: ApplyOptions

  #### Returns {
  anomalies?: MinilinkError[];
  data: L[];
  errors?: MinilinkError[];
  plainLinks: L[];
  }

  - ##### `Optional` anomalies?: MinilinkError[]

  - ##### data: L[]

  - ##### `Optional` errors?: MinilinkError[]

  - ##### plainLinks: L[]

  - Defined in work/deeplinks/deeplinks/imports/minilinks.tsx:111

### id

- id(start, ...path): Id

- #### Parameters

  - start: DeepClientStartItem
  - `Rest`...path: DeepClientPathItem[]

  #### Returns Id

  - Defined in work/deeplinks/deeplinks/imports/minilinks.tsx:98

### name

- name(input): string

- #### Parameters

  - input: Id | Link<Id>

  #### Returns string

  - Defined in work/deeplinks/deeplinks/imports/minilinks.tsx:99

### query

- query(query): any

- #### Parameters

  - query: Id | QueryLink

  #### Returns any

  - Defined in work/deeplinks/deeplinks/imports/minilinks.tsx:96

### remove

- remove(idsArray, applyName?): {
  anomalies?: MinilinkError[];
  errors?: MinilinkError[];
  }

- #### Parameters

  - idsArray: any[]
  - `Optional` applyName: string

  #### Returns {
  anomalies?: MinilinkError[];
  errors?: MinilinkError[];
  }

  - ##### `Optional` anomalies?: MinilinkError[]

  - ##### `Optional` errors?: MinilinkError[]

  - Defined in work/deeplinks/deeplinks/imports/minilinks.tsx:106

### select

- select(query, options?): any

- #### Parameters

  - query: Id | QueryLink
  - `Optional` options: MinilinksQueryOptions<MinilinksQueryOptionAggregate>

  #### Returns any

  - Defined in work/deeplinks/deeplinks/imports/minilinks.tsx:97

### subscribe

- subscribe(query, options?): Observable<any>

- #### Parameters

  - query: Id | QueryLink
  - `Optional` options: MinilinksQueryOptions<MinilinksQueryOptionAggregate>

  #### Returns Observable<any>

  - Defined in work/deeplinks/deeplinks/imports/minilinks.tsx:101

### symbol

- symbol(input): string

- #### Parameters

  - input: Id | Link<Id>

  #### Returns string

  - Defined in work/deeplinks/deeplinks/imports/minilinks.tsx:100

### update

- update(linksArray, applyName?): {
  anomalies?: MinilinkError[];
  errors?: MinilinkError[];
  }

- #### Parameters

  - linksArray: any[]
  - `Optional` applyName: string

  #### Returns {
  anomalies?: MinilinkError[];
  errors?: MinilinkError[];
  }

  - ##### `Optional` anomalies?: MinilinkError[]

  - ##### `Optional` errors?: MinilinkError[]

  - Defined in work/deeplinks/deeplinks/imports/minilinks.tsx:117